# Class VulkanMemoryRequirements.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanMemoryRequirements.Builder

Enclosing class:
  `VulkanMemoryRequirements`

public static final class VulkanMemoryRequirements.Builder extends Object
Builds instances of type `VulkanMemoryRequirements`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanMemoryRequirements`
  `build()`
  Builds a new `VulkanMemoryRequirements`.
  `final VulkanMemoryRequirements.Builder`
  `from(VulkanMemoryRequirementsType instance)`
  Fill a builder with attribute values from the provided `VulkanMemoryRequirementsType` instance.
  `final VulkanMemoryRequirements.Builder`
  `setAlignment(long alignment)`
  Initializes the value for the `alignment` attribute.
  `final VulkanMemoryRequirements.Builder`
  `setMemoryTypeBits(int memoryTypeBits)`
  Initializes the value for the `memoryTypeBits` attribute.
  `final VulkanMemoryRequirements.Builder`
  `setSize(long size)`
  Initializes the value for the `size` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanMemoryRequirements.Builder from(VulkanMemoryRequirementsType instance)
    Fill a builder with attribute values from the provided `VulkanMemoryRequirementsType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setSize

    public final VulkanMemoryRequirements.Builder setSize(long size)
    Initializes the value for the `size` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `size`.

    Parameters:
      `size` - The value for size
    Returns:
      `this` builder for use in a chained invocation

  - ### setAlignment

    public final VulkanMemoryRequirements.Builder setAlignment(long alignment)
    Initializes the value for the `alignment` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `alignment`.

    Parameters:
      `alignment` - The value for alignment
    Returns:
      `this` builder for use in a chained invocation

  - ### setMemoryTypeBits

    public final VulkanMemoryRequirements.Builder setMemoryTypeBits(int memoryTypeBits)
    Initializes the value for the `memoryTypeBits` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `memoryTypeBits`.

    Parameters:
      `memoryTypeBits` - The value for memoryTypeBits
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanMemoryRequirements build()
    Builds a new `VulkanMemoryRequirements`.
    Returns:
      An immutable instance of VulkanMemoryRequirements
    Throws:
      `IllegalStateException` - if any required attributes are missing